# Basic implementation of an Alert box.
#
# Warning: This has not been tested against a real MoinMoin
# implementation.  There could be security issues or other bugs.
#
# Warning: get rid of "https://help.ubuntu.com" in the src attributes
# of the <img> tags before using this on a real site.
#
# TODO: is there a way of parsing markup in the message?

# Used by the macro_Alert() to check validity of icon files
import re

#
# General Alert() macro
#

# Semantically cleaner, not compatible with IE6
#alert_template = '<p%(COLOR)s class="alert %(IMAGE)s"><img alt="%(ALT)s" title="%(ICON_TITLE)s" src="https://help.ubuntu.com/community/IconsPage?action=AttachFile&do=get&target=%(IMAGE)s.png" class="alert-icon"><span class="alert-text"><strong class="alert-title">%(TEXT_TITLE)s</strong>%(MESSAGE)s</p>'
# Tables for formatting (yuck), but IE-compatible
alert_template = '<table%(COLOR)s class="alert %(IMAGE)s"><tr><td><img alt="%(ALT)s" title="%(ICON_TITLE)s" src="https://help.ubuntu.com/community/IconsPage?action=AttachFile&do=get&target=%(IMAGE)s.png" class="alert-icon"></td><td class="alert-text">%(MESSAGE)s</td></tr></table>'

def execute(macro, message, text_title, icon_file, icon_alt, icon_title, icon_longdesc, color=None):
    """ Create an Alert Box.  Specific styles of alert are just sugar
    
    @param macro: global macro object
    @param message: text of the message to display
    @param text_title: title of the message to display
    @param icon_file: name of the file for the icon, without path or filetype
    @param icon_alt: alt text for the icon
    @param icon_title: title text for the icon
    @param icon_longdesc: long description for the icon

    @rtype: unicode
    @return: snippet of HTML displaying an icon
    """

    # http://evil.com/icon.png not allowed
    if re.compile('[^A-Za-z0-9]').search(icon_file): icon_file="IconWarning"

    if color is None:
        color=''
    else:
        color=' style="background-color: %s ! important"' % color

    return alert_template % {
        'COLOR'     : macro.request.formatter.text(color),
        'IMAGE'     : macro.request.formatter.text(icon_file),
        'ALT'       : macro.request.formatter.text(icon_alt),
        'ICON_TITLE': macro.request.formatter.text(icon_title),
        'TEXT_TITLE': macro.request.formatter.text(text_title),
        'MESSAGE'   : macro.request.formatter.text(message),
        }
